View Issue Details

IDProjectCategoryView StatusLast Update
0004147unrealircdpublic2012-12-26 20:13
ReporterwolfwoodAssigned Tonenolod 
PrioritylowSeverityfeatureReproducibilityN/A
Status resolvedResolutionfixed 
Product Version3.2.10-rc1 
Target VersionFixed in Version3.4-alpha1 
Summary0004147: Backport DH Parameters setting from devel branch
DescriptionI was thinking that it might be worth while to backport this feature for perfect forward secrecy and DSA key usage. I went ahead and extracted a patch for it from the old devel branch and it seems to be working okay, although I've only been testing it for a day. I've included the patch I generated based on 3.2.10-rc1.
TagsNo tags attached.
3rd party modules

Activities

wolfwood

2012-11-26 04:52

reporter  

dhparam.diff (3,597 bytes)

nenolod

2012-12-02 05:46

reporter   ~0017251

It is now in 3.4. Syzop will decide if we will transplant it over to 3.2.

http://hg.unrealircd.org/hg/unreal/rev/d347f6c66d9f
- Add support for providing a DH parameters file. (0004147)
DH parameters files must be encoded in PEM format, and the path is
set using the ssl::dh config setting. This is based on a patch
submitted by wolfwood, with some modifications to avoid using stdio
unnecessarily and to avoid code duplication.

Thank you for your patch!

wolfwood

2012-12-20 06:01

reporter   ~0017275

I think I found a small problem in the new version of the patch you produced.

    3.45 SSL_CTX_set_default_passwd_cb(ctx_client, ssl_pem_passwd_cb);
    3.46 SSL_CTX_set_session_cache_mode(ctx_client, SSL_SESS_CACHE_OFF);
    3.47 +
    3.48 + setup_dh_params(ctx_server);
    3.49 +

I think it should be:

    3.45 SSL_CTX_set_default_passwd_cb(ctx_client, ssl_pem_passwd_cb);
    3.46 SSL_CTX_set_session_cache_mode(ctx_client, SSL_SESS_CACHE_OFF);
    3.47 +
    3.48 + setup_dh_params(ctx_client);
    3.49 +

Thanks!

nenolod

2012-12-26 20:13

reporter   ~0017284

Typo fixed in: http://hg.unrealircd.org/hg/unreal/rev/309e1fd4175f

Thanks for pointing it out!

Issue History

Date Modified Username Field Change
2012-11-26 04:52 wolfwood New Issue
2012-11-26 04:52 wolfwood File Added: dhparam.diff
2012-12-02 05:46 nenolod Note Added: 0017251
2012-12-02 05:46 nenolod Status new => resolved
2012-12-02 05:46 nenolod Fixed in Version => 3.4-alpha1
2012-12-02 05:46 nenolod Resolution open => fixed
2012-12-02 05:46 nenolod Assigned To => nenolod
2012-12-20 06:01 wolfwood Note Added: 0017275
2012-12-20 06:01 wolfwood Status resolved => feedback
2012-12-20 06:01 wolfwood Resolution fixed => reopened
2012-12-26 20:13 nenolod Note Added: 0017284
2012-12-26 20:13 nenolod Status feedback => resolved
2012-12-26 20:13 nenolod Resolution reopened => fixed